Index: src/settings.cpp
===================================================================
--- src/settings.cpp	(revision 13552)
+++ src/settings.cpp	(working copy)
@@ -63,6 +63,8 @@
 #include "gamelog.h"
 #include "station_func.h"
 
+#include "sharedinfrastructure.h"
+
 #include "table/strings.h"
 
 ClientSettings _settings_client;
@@ -1747,7 +1749,27 @@
  SDT_CONDOMANY(GameSettings, locale.currency,                               SLE_UINT8, 97, SL_MAX_VERSION, N, 0, 0, CUSTOM_CURRENCY_ID, "GBP|USD|EUR|YEN|ATS|BEF|CHF|CZK|DEM|DKK|ESP|FIM|FRF|GRD|HUF|ISK|ITL|NLG|NOK|PLN|ROL|RUR|SIT|SEK|YTL|SKK|BRR|custom", STR_NULL, NULL, NULL),
  SDT_CONDOMANY(GameSettings, locale.units,                                  SLE_UINT8, 97, SL_MAX_VERSION, N, 0, 1, 2, "imperial|metric|si", STR_NULL, NULL, NULL),
 
+
 	/***************************************************************************/
+	/* Shared Infrastructure configure patches window */
+	SDT_CONDBOOL(GameSettings, sharing.shared_railway_stations,         123,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_RAILWAY_STATIONS, SettingsEnableSharedRailwayStations),
+	SDT_CONDBOOL(GameSettings, sharing.shared_railway_tracks,           123,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_RAILWAY_TRACKS, SettingsEnableSharedRailwayTracks),
+	SDT_CONDBOOL(GameSettings, sharing.shared_railway_depots,           123,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_RAILWAY_DEPOTS, SettingsEnableSharedRailwayStations),
+	SDT_CONDBOOL(GameSettings, sharing.shared_road_depots,              123,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_ROAD_DEPOTS, NULL),
+	SDT_CONDBOOL(GameSettings, sharing.shared_road_stops,               123,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_ROAD_STOPS, NULL),
+	SDT_CONDBOOL(GameSettings, sharing.shared_water_depots,             123,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_WATER_DEPOTS, NULL),
+	SDT_CONDBOOL(GameSettings, sharing.shared_harbours,                 123,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_HARBOURS, NULL),
+	SDT_CONDBOOL(GameSettings, sharing.shared_airports,                 123,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_AIRPORTS, NULL),
+	SDT_CONDVAR (GameSettings, sharing.shared_provision, SLE_UINT8,     123,SL_MAX_VERSION,   0, 0,  10,  0,  100,  5, STR_CONFIG_PATCHES_SHARED_PROVISION, NULL),
+	SDT_CONDVAR (GameSettings, sharing.shared_tontile_cost, SLE_UINT16, 123,SL_MAX_VERSION,   0, CR, 30,  0,  250,  5, STR_CONFIG_PATCHES_SHARED_TONTILE_COST, NULL),
+	SDT_CONDVAR (GameSettings, sharing.shared_landing_fee, SLE_UINT16,  123,SL_MAX_VERSION,   0, CR, 50,  0, 1000, 20, STR_CONFIG_PATCHES_SHARED_LANDING_FEE, NULL),
+	SDT_CONDVAR (GameSettings, sharing.shared_road_stops_fee, SLE_UINT8, 123,SL_MAX_VERSION,  0, CR,  5,  0,   50,  1, STR_CONFIG_PATCHES_SHARED_ROAD_STOPS_FEE, NULL),
+	SDT_CONDVAR (GameSettings, sharing.shared_harbours_fee,  SLE_UINT8, 123,SL_MAX_VERSION,   0, CR, 10,  0,  200,  5, STR_CONFIG_PATCHES_SHARED_HARBOURS_FEE, NULL),
+	SDT_CONDBOOL(GameSettings, sharing.shared_player_level,             123,SL_MAX_VERSION,   0, D0, false,            STR_CONFIG_PATCHES_SHARED_PLAYER_LEVEL, NULL),
+	SDT_CONDVAR (GameSettings, sharing.shared_delay, SLE_UINT8,         123,SL_MAX_VERSION,   0, 0,  6,   0,   60,  1, STR_CONFIG_PATCHES_SHARED_DELAY, NULL),
+
+
+	/***************************************************************************/
 	/* Unsaved patch variables. */
 	SDTC_OMANY(gui.autosave,                  SLE_UINT8, S,  0, 1, 4, "off|monthly|quarterly|half year|yearly", STR_NULL,                     NULL),
 	 SDTC_BOOL(gui.vehicle_speed,                        S,  0,  true,                        STR_CONFIG_PATCHES_VEHICLESPEED,                NULL),
@@ -1818,7 +1840,6 @@
 	  SDTC_STR(network.last_host,              SLE_STRB, S,  0, "0.0.0.0",                    STR_NULL,                                       NULL),
 	  SDTC_VAR(network.last_port,            SLE_UINT16, S,  0,     0,     0,  UINT16_MAX, 0, STR_NULL,                                       NULL),
 #endif /* ENABLE_NETWORK */
-
 	/*
 	 * Since the network code (CmdChangePatchSetting and friends) use the index in this array to decide
 	 * which patch the server is talking about all conditional compilation of this array must be at the
@@ -1830,7 +1851,6 @@
 	/* We might need to emulate a right mouse button on mac */
 	 SDTC_VAR(gui.right_mouse_btn_emulation, SLE_UINT8, S, MS, 0, 0, 2, 0, STR_CONFIG_PATCHES_RIGHT_MOUSE_BTN_EMU, NULL),
 #endif
-
 	SDT_END()
 };
 
Index: src/depot_base.h
===================================================================
--- src/depot_base.h	(revision 13552)
+++ src/depot_base.h	(working copy)
@@ -27,6 +27,8 @@
 	return index < GetDepotPoolSize() && GetDepot(index)->IsValid();
 }
 
+static const DepotID INVALID_DEPOT = 0xFFFF;
+
 Depot *GetDepotByTile(TileIndex tile);
 
 #define FOR_ALL_DEPOTS_FROM(d, start) for (d = GetDepot(start); d != NULL; d = (d->index + 1U < GetDepotPoolSize()) ? GetDepot(d->index + 1U) : NULL) if (d->IsValid())
Index: src/settings_gui.cpp
===================================================================
--- src/settings_gui.cpp	(revision 13552)
+++ src/settings_gui.cpp	(working copy)
@@ -704,6 +704,24 @@
 	"vehicle.dynamic_engines",
 };
 
+static const char *_patches_shared_infrastructure[] = {
+		"shared_railway_stations",
+		"shared_railway_tracks",
+		"shared_railway_depots",
+		"shared_road_stops",
+		"shared_road_depots",
+		"shared_harbours",
+		"shared_water_depots",
+		"shared_airports",
+		"shared_provision",
+		"shared_tontile_cost",
+		"shared_landing_fee",
+		"shared_road_stops_fee",
+		"shared_harbours_fee",
+		"shared_player_level",
+		"shared_delay",
+};
+
 struct PatchEntry {
 	const SettingDesc *setting;
 	uint index;
@@ -725,6 +743,7 @@
 	{_patches_stations,     NULL, lengthof(_patches_stations)},
 	{_patches_economy,      NULL, lengthof(_patches_economy)},
 	{_patches_ai,           NULL, lengthof(_patches_ai)},
+	{_patches_shared_infrastructure, NULL, lengthof(_patches_shared_infrastructure)},
 };
 
 enum PatchesSelectionWidgets {
@@ -734,7 +753,8 @@
 	PATCHSEL_VEHICLES,
 	PATCHSEL_STATIONS,
 	PATCHSEL_ECONOMY,
-	PATCHSEL_COMPETITORS
+	PATCHSEL_COMPETITORS,
+	PATCHSEL_SHARING
 };
 
 struct PatchesSelectionWindow : Window {
@@ -930,6 +950,7 @@
 
 			case PATCHSEL_INTERFACE: case PATCHSEL_CONSTRUCTION: case PATCHSEL_VEHICLES:
 			case PATCHSEL_STATIONS:  case PATCHSEL_ECONOMY:      case PATCHSEL_COMPETITORS:
+			case PATCHSEL_SHARING:
 				this->RaiseWidget(this->page + PATCHSEL_INTERFACE);
 				this->page = widget - PATCHSEL_INTERFACE;
 				this->LowerWidget(this->page + PATCHSEL_INTERFACE);
@@ -976,6 +997,7 @@
 {    WWT_TEXTBTN,   RESIZE_NONE,     3,   271,   357,    16,    27, STR_CONFIG_PATCHES_STATIONS,     STR_NULL},
 {    WWT_TEXTBTN,   RESIZE_NONE,     3,    10,    96,    28,    39, STR_CONFIG_PATCHES_ECONOMY,      STR_NULL},
 {    WWT_TEXTBTN,   RESIZE_NONE,     3,    97,   183,    28,    39, STR_CONFIG_PATCHES_AI,           STR_NULL},
+{    WWT_TEXTBTN,   RESIZE_NONE,     3,   184,   270,    28,    39, STR_CONFIG_PATCHES_SHARED,       STR_NULL},
 {   WIDGETS_END},
 };
 
Index: src/npf.cpp
===================================================================
--- src/npf.cpp	(revision 13552)
+++ src/npf.cpp	(working copy)
@@ -24,6 +24,7 @@
 #include "vehicle_base.h"
 #include "settings_type.h"
 #include "tunnelbridge.h"
+#include "sharedinfrastructure.h"
 
 static AyStar _npf_aystar;
 
@@ -465,25 +466,37 @@
  */
 static bool CanEnterTileOwnerCheck(Owner owner, TileIndex tile, DiagDirection enterdir)
 {
-	if (IsTileType(tile, MP_RAILWAY) ||             /* Rail tile (also rail depot) */
-			IsRailwayStationTile(tile) ||   /* Rail station tile */
-			IsRoadDepotTile(tile) ||        /* Road depot tile */
-			IsStandardRoadStopTile(tile)) { /* Road station tile (but not drive-through stops) */
-		return IsTileOwner(tile, owner); /* You need to own these tiles entirely to use them */
-	}
+	unsigned char tileOwner = IsTileOwner(tile,owner);
+	if(IsTileType(tile, MP_RAILWAY) && !IsRailwayStation(tile))
+		return ( tileOwner || SharedTracks(tile,owner));
 
+	if (IsRailwayStation(tile))
+	  	return ( tileOwner || SharedRailwayStations(tile,owner));
+
+	if (IsDepotTypeTile(tile, TRANSPORT_RAIL))
+		return ( tileOwner || SharedRailwayDepots(tile,owner));
+
+	if (IsDepotTypeTile(tile, TRANSPORT_ROAD))
+		return ( tileOwner || SharedRoadDepots(tile,owner));
+
+	if (IsStandardRoadStopTile(tile))
+		return ( tileOwner || SharedRoadStops(tile,owner));
+
+	if (IsDepotTypeTile(tile, TRANSPORT_WATER))
+		return ( tileOwner || SharedWaterDepots(tile,owner));
+
 	switch (GetTileType(tile)) {
 		case MP_ROAD:
 			/* rail-road crossing : are we looking at the railway part? */
 			if (IsLevelCrossing(tile) &&
 					DiagDirToAxis(enterdir) != GetCrossingRoadAxis(tile)) {
-				return IsTileOwner(tile, owner); /* Railway needs owner check, while the street is public */
+ 				return (tileOwner || SharedTracks(tile,owner)); /* Railway needs owner check, while the street is public */
 			}
 			break;
 
 		case MP_TUNNELBRIDGE:
 			if (GetTunnelBridgeTransportType(tile) == TRANSPORT_RAIL) {
-				return IsTileOwner(tile, owner);
+ 				return (tileOwner || SharedTracks(tile,owner));
 			}
 			break;
 
@@ -880,7 +893,7 @@
 	FOR_ALL_DEPOTS(depot) {
 		/* Check if this is really a valid depot, it is of the needed type and
 		 * owner */
-		if (IsDepotTypeTile(depot->xy, type) && IsTileOwner(depot->xy, owner))
+		if (IsDepotTypeTile(depot->xy, type) && ((IsTileOwner(depot->xy, owner)||SharedDepotTransport(depot->xy,owner,type))))
 			/* If so, let's add it to the queue, sorted by distance */
 			depots.push(&depots, depot, DistanceManhattan(tile, depot->xy));
 	}
Index: src/saveload.cpp
===================================================================
--- src/saveload.cpp	(revision 13552)
+++ src/saveload.cpp	(working copy)
@@ -36,7 +36,7 @@
 
 #include "table/strings.h"
 
-extern const uint16 SAVEGAME_VERSION = 98;
+extern const uint16 SAVEGAME_VERSION = 97;
 
 SavegameType _savegame_type; ///< type of savegame we are loading
 
Index: src/rail_cmd.cpp
===================================================================
--- src/rail_cmd.cpp	(revision 13552)
+++ src/rail_cmd.cpp	(working copy)
@@ -2285,7 +2285,16 @@
 	byte fract_coord_leave;
 	DiagDirection dir;
 	int length;
+	Owner trackowner;
 
+	/* Account for use of shared tracks */
+	if (v->tile != tile && IsFrontEngine(v)) {
+		trackowner = GetTileOwner(tile);
+		if (trackowner != v->owner) {
+			v->shared_tontiles[trackowner] += v->u.rail.cached_weight;
+		}
+	}
+
 	/* this routine applies only to trains in depot tiles */
 	if (v->type != VEH_TRAIN || !IsRailDepotTile(tile)) return VETSB_CONTINUE;
 
Index: src/date.cpp
===================================================================
--- src/date.cpp	(revision 13552)
+++ src/date.cpp	(working copy)
@@ -175,6 +175,8 @@
 extern void TownsMonthlyLoop();
 extern void IndustryMonthlyLoop();
 extern void StationMonthlyLoop();
+extern void SharedTracksPayment();
+extern void SharedSettingDelay();
 
 extern void PlayersYearlyLoop();
 extern void TrainsYearlyLoop();
@@ -270,6 +272,9 @@
 #ifdef ENABLE_NETWORK
 		if (_network_server) NetworkServerMonthlyLoop();
 #endif /* ENABLE_NETWORK */
+ 		SharedTracksPayment();
+ 		SharedSettingDelay();
+
 	}
 
 	/* check if we entered a new year? */
Index: src/station_cmd.cpp
===================================================================
--- src/station_cmd.cpp	(revision 13552)
+++ src/station_cmd.cpp	(working copy)
@@ -3252,10 +3252,10 @@
 				cp->source          = (CheckSavegameVersion(7) && _cargo_source == 0xFF) ? INVALID_STATION : _cargo_source;
 				cp->count           = GB(_waiting_acceptance, 0, 12);
 				cp->days_in_transit = _cargo_days;
-				cp->feeder_share    = _cargo_feeder_share;
+				cp->feeder_share[0] = _cargo_feeder_share;
 				cp->source_xy       = _cargo_source_xy;
 				cp->days_in_transit = _cargo_days;
-				cp->feeder_share    = _cargo_feeder_share;
+				cp->feeder_share[0] = _cargo_feeder_share;
 				SB(ge->acceptance_pickup, GoodsEntry::PICKUP, 1, 1);
 				ge->cargo.Append(cp);
 			}
Index: src/news_type.h
===================================================================
--- src/news_type.h	(revision 13552)
+++ src/news_type.h	(working copy)
@@ -42,6 +42,7 @@
 	NS_COMPANY_MERGER,   ///< NT_COMPANY_INFO (merger)
 	NS_COMPANY_BANKRUPT, ///< NT_COMPANY_INFO (bankrupt)
 	NS_COMPANY_NEW,      ///< NT_COMPANY_INFO (new company)
+	NS_COMPANY_SHARING,  ///< NT_COMPANY_INFO (change sharing)
 	NS_OPENCLOSE,        ///< NT_OPENCLOSE
 	NS_ECONOMY,          ///< NT_ECONOMY
 	NS_INDUSTRY_PLAYER,  ///< NT_INDUSTRY_PLAYER
Index: src/ship_cmd.cpp
===================================================================
--- src/ship_cmd.cpp	(revision 13552)
+++ src/ship_cmd.cpp	(working copy)
@@ -41,6 +41,7 @@
 #include "settings_type.h"
 #include "order_func.h"
 #include "effectvehicle_func.h"
+#include "sharedinfrastructure.h"
 
 #include "table/strings.h"
 
@@ -342,6 +343,9 @@
 
 static void ShipArrivesAt(const Vehicle* v, Station* st)
 {
+	/* check station fee for shared harbours */
+	if (st->owner != v->owner) SharedStationFee(st->owner, v->index);
+
 	/* Check if station was ever visited before */
 	if (!(st->had_vehicle_of_type & HVOT_SHIP)) {
 		st->had_vehicle_of_type |= HVOT_SHIP;
@@ -764,7 +768,7 @@
 	/* The ai_new queries the vehicle cost before building the route,
 	 * so we must check against cheaters no sooner than now. --pasky */
 	if (!IsShipDepotTile(tile)) return CMD_ERROR;
-	if (!IsTileOwner(tile, _current_player)) return CMD_ERROR;
+	if (!IsTileOwner(tile, _current_player) && !SharedWaterDepots(tile, _current_player)) return CMD_ERROR;
 
 	unit_num = HasBit(p2, 0) ? 0 : GetFreeUnitNumber(VEH_SHIP);
 
@@ -834,6 +838,8 @@
 		GetPlayer(_current_player)->num_engines[p1]++;
 	}
 
+	SharedDepotProvision(value, GetTileOwner(tile), flags);
+
 	return value;
 }
 
Index: src/order_cmd.cpp
===================================================================
--- src/order_cmd.cpp	(revision 13552)
+++ src/order_cmd.cpp	(working copy)
@@ -27,6 +27,7 @@
 #include "vehicle_func.h"
 #include "oldpool_func.h"
 #include "depot_base.h"
+#include "sharedinfrastructure.h"
 
 #include "table/strings.h"
 
@@ -330,7 +331,7 @@
 
 			const Station *st = GetStation(new_order.GetDestination());
 
-			if (st->owner != OWNER_NONE && !CheckOwnership(st->owner)) {
+			if (st->owner != OWNER_NONE && ((!CheckOwnership(st->owner))&&!SharedStation(st->xy,v->owner,v->type))) {
 				return CMD_ERROR;
 			}
 
@@ -385,18 +386,18 @@
 
 					const Station *st = GetStation(new_order.GetDestination());
 
-					if (!CheckOwnership(st->owner) ||
-							!(st->facilities & FACIL_AIRPORT) ||
-							st->Airport()->nof_depots == 0 ||
-							!CanAircraftUseStation(v->engine_type, st)) {
-						return CMD_ERROR;
-					}
-				} else {
+				if (((!CheckOwnership(st->owner))&&(!SharedAirports(st->xy,v->owner))) ||
+						!(st->facilities & FACIL_AIRPORT) ||
+						st->Airport()->nof_depots == 0 ||
+						!CanAircraftUseStation(v->engine_type, st)) {
+					return CMD_ERROR;
+				}
+			} else {
 					if (!IsValidDepotID(new_order.GetDestination())) return CMD_ERROR;
 
 					const Depot *dp = GetDepot(new_order.GetDestination());
 
-					if (!CheckOwnership(GetTileOwner(dp->xy))) return CMD_ERROR;
+				if ((!CheckOwnership(GetTileOwner(dp->xy)))&&(!SharedDepotVehicleType(dp->xy,v->owner,v->type))) return CMD_ERROR;
 
 					switch (v->type) {
 						case VEH_TRAIN:
@@ -431,7 +432,7 @@
 			if (!IsValidWaypointID(new_order.GetDestination())) return CMD_ERROR;
 			const Waypoint *wp = GetWaypoint(new_order.GetDestination());
 
-			if (!CheckOwnership(GetTileOwner(wp->xy))) return CMD_ERROR;
+			if ((!CheckOwnership(GetTileOwner(wp->xy)))&&(!SharedTracks(wp->xy,v->owner))) return CMD_ERROR;
 
 			/* Order flags can be any of the following for waypoints:
 			 * [non-stop]
Index: src/window_type.h
===================================================================
--- src/window_type.h	(revision 13552)
+++ src/window_type.h	(working copy)
@@ -94,6 +94,7 @@
 	WC_BUILD_SIGNAL,
 	WC_COMPANY_PASSWORD_WINDOW,
 	WC_OSK,
+	WC_SHARED_INFRASTRUCTURE,
 
 	WC_INVALID = 0xFFFF
 };
